program setmenu;
{ Laden eines Menusystems fuer ges-WINDOWS
  (C) 1987 by Ruediger Nahm
  26.12.87
}
const
  PRGNAME= 'setmenu';
  LINE_LEN= 80; { maximale Zeilenlaenge }
  PAGE_LEN= 24; { Seitenlaenge }

type
  Anystring= String[LINE_LEN];

var
  infile: Text; { Eingabedatei mit Menudaten }
  lbuff: Anystring; { zum Einlesen einer Zeile }
  fname: String[14]; { Name der Eingabadatei }
  menu_id: Char; { zu welchem Fenster gehoeren die Menues }
  wdw_id: Char; { id des Menuefensters }
  lcount: Integer; { Zaehler fuer gelesene Zeilen }
  lmax: Integer; { maximal erreichte Zeilenlaenge }
  m_wdw: array[0..PAGE_LEN] of Anystring;
  wdw_id_found: Boolean; { wurde schon ein Id gefunden }
  m_count: Integer; { Zaehler fuer gelesene Menufenster }
  ml_count: Integer; { Zaehler fuer gelesene Zeilen im aktuellen Menufenster }
  s_lin: Anystring; { aufgebaute Statuszeile }
  end_wdw: Boolean; { Ende des Fensters erreicht }
  end_menu: Boolean; { Ende des Menus erreicht }
  o_count: Integer; { Zaehlvariable }
  s_stat: Byte; { index des Menupunkts in der statuszeile }
  ch: Char; { zum Lesen }
  cond_y,cond_x: Byte; { fuer Bedingung }
  cond: Anystring; { fuer Bedingung }

procedure init_wdws;
  begin
    write(#27'$@');
  end;

procedure error( errno, erraddr: Integer);
  const
    { in hi(errno) steht : }
    BREAK=0;  { user break }
    IOERR=1;  { IO-Error }
    RTERR=2;  { runtime-error }

    { IO-Fehler }
    NO_SUCH_FILE= 01;     { Datei nicht vorhanden }
    CANT_READ=    02;     { Datei kann nicht gelesen werden }
    READ_PAST_EOF=99;     { Lesen nach EOF }
  begin
    init_wdws;
    case hi(errno) of
      IOERR:
        begin
          case lo(errno) of
            NO_SUCH_FILE:
              begin init_wdws; writeln(PRGNAME,': can`t access ',fname); halt; end;

            READ_PAST_EOF:
              begin
                init_wdws;
                writeln(PRGNAME,': unexpected end of source,', fname,
                        ' line ',lcount);
                halt;
              end;
          end;
        end;
    end;
  end;

procedure open( id: Char; y, x, dy, dx : Byte);
  { eroeffne Fenster id }
  begin
    write( #27'$O',id,chr(32 + y),chr(32+x),chr(32+dy),chr(32+dx));
  end;

procedure ass_menu( id: Char; no_menu: Byte);
  { setze das aktuelle Fenster als Menu fuer Fenster id mit Nummer no_menu }
  begin
    write( #27'$M',id,chr(32+no_menu));
  end;

procedure fix_wdw;
  begin
    write(#27'$J');
  end;

procedure set_cond( y,x: Byte; s:Anystring );
  begin
    writeln( #27'$P',chr(y+32),chr(x+32),s);
  end;

begin
  { error-handler umsetzen }
  errorptr:= addr(error);

  { Anzahl der Parameter ueberpruefen }
  if paramcount <> 1 then
    begin writeln('usage: ',PRGNAME,' <FILE>'); exit; end
  else
    fname:= paramstr(1);

  { Datei eroeffnen }
  assign( infile, fname); reset(infile);

  init_wdws;
  lcount:= 0;
  while not eof(infile) do
    begin
      { hole eine Zeile }
      read(infile, ch);
      if ch = #10 then lcount:= succ(lcount);
      if ch='@' then
        begin
          { lies Menue_id ein }
          readln(infile,menu_id); lcount:= succ(lcount); end_menu:= false;
          s_lin:= ''; { noch leere Statuszeile }
          m_count:= 0; { noch kein Menufenster }
          while not eof(infile) and not end_menu do
            begin
              wdw_id_found:= false;
              cond:=''; { noch keine Bedingung }

              { warte auf '#' + <ID> }
              while not eof(infile) and not wdw_id_found do
                begin
                  read(infile,ch);
                  if ch= #10 then lcount:= succ(lcount);
                  if ch = '#' then
                    begin
                      wdw_id_found:= true;
                      readln(infile,wdw_id); lcount:= lcount+1;
                    end;
                end;

              if not eof(infile) then
                begin
                  { id gefunden }
                  ml_count:= 0; { noch keine Zeilen im aktuellen Menu }
                  lmax:= 0; { noch Zeilenlaenge 0 }
                  end_wdw:= false;

                  { schaue nach, ob Bedingung vorhanden }
                  read(infile,ch); lcount:= succ(lcount);
                  if ch = '?' then
                    begin
                      readln(infile,cond_y,cond_x,cond);
                      while ( length(cond) > 0) and ( cond[1]=' ') do
                        delete(cond,1,1);
                    end
                  else
                    begin
                      readln(infile,lbuff); lbuff:= ch+lbuff;
                    end;

                  { hole Menuetext in der Statuszeile }
                  if ch = '?' then
                    begin
                      readln( infile, lbuff);
                      lcount:= succ(lcount);
                    end;
                  s_stat:= length(s_lin); s_lin:= s_lin+ lbuff + ' ';

                  { lies ein Fenster }
                  while (ml_count<=PAGE_LEN) and not end_wdw do
                    begin
                      readln(infile,lbuff); lcount:= succ(lcount);
                      if length(lbuff) > lmax then lmax:= length(lbuff);
                      if ( length(lbuff) > 0 ) and ( lbuff[1] = '#' ) then
                        end_wdw:= true
                      else
                        begin
                          m_wdw[ml_count]:= lbuff; ml_count:= succ(ml_count);
                        end;
                    end;

                  if not end_wdw then
                    begin
                      init_wdws;
                      writeln( PRGNAME,': menu too long, menu ',wdw_id,
                               ' line ',lcount);
                      halt;
                    end;

                  if ml_count<= 1 then
                    begin
                      init_wdws;
                      writeln(PRGNAME,': empty menu <',wdw_id,'>');
                      halt;
                    end;

                  { Fenster komplett eingelesen }
                  lmax:= succ(lmax); { rechts noch Platz halten }
                  if s_stat + lmax > LINE_LEN then
                    begin
                      { Fenster kann nicht buendig eroeffnet werden }
                      open( wdw_id, ml_count-1, lmax,
                            PAGE_LEN- ml_count+1, LINE_LEN - lmax );
                    end
                  else
                    begin
                      { Fenster linksbuendig eroeffnen }
                      open( wdw_id, ml_count-1, lmax,
                            PAGE_LEN- ml_count+1, s_stat);
                    end;

                  set_cond(cond_y,cond_x,cond);
                  writeln(#27'f',m_wdw[0]);
                  ass_menu(menu_id,m_count);

                  for o_count:= 1 to ml_count-1 do
                    begin
                      write( m_wdw[o_count]);
                      if o_count < ml_count-1 then writeln;
                    end;

                  m_count:= succ(m_count);
                end;
            end;
        end;
    end;

  write(#27'$S',menu_id);
  writeln(#27'f',s_lin);
  fix_wdw;
  close(infile);
end.